#pragma semicolon 1

#include <vip>
#include <sdkhooks>

public Plugin:myinfo = 
{
	name	= "VIP [Ring of Fog]",
	author	= "wS",
	version = "1.0.2"
};

#define ITEM_NAME "ring_of_fog"

new bool:g_bAccess[MAXPLAYERS + 1];
new Float:g_fDistance; // min 39.3 units = 1 meter

public OnPluginStart()
{
	if (!VIP_RegisterItem(ITEM_NAME, VIP_ITEM_TOGGLE))
		SetFailState("VIP_RegisterItem error (%s)", ITEM_NAME);
	
	LoadTranslations("vip_modules_description.phrases");
	
	new Handle:hCvar = CreateConVar("ring_of_fog_distance", "20", "Расстояние в метрах для активации кольца тумана", _, true, 1.0);
	g_fDistance = GetConVarFloat(hCvar) * 39.3;
	HookConVarChange(hCvar, CvarChanged);
	AutoExecConfig(true, ITEM_NAME, "vip/modules/ring_of_fog");
}

public CvarChanged(Handle:hCvar, const String:OldValue[], const String:NewValue[])
	g_fDistance = StringToFloat(NewValue) * 39.3;

///////////////////////////////////////////////////////////////////////////////////

public bool:VIP_CurrentItemValue(client, ItemID, String:ItemValue[], ItemValueSize)
{
	if (g_bAccess[client])
	{
		IntToString(1, ItemValue, ItemValueSize);
		return true;
	}
	ItemValue[0] = 0;
	return false;
}

public bool:VIP_Description(client, ItemID, String:ItemValue[ITEM_INFO_LENGTH], String:description[], description_size)
{
	FormatEx(description, description_size, "%T", ITEM_NAME, client, g_fDistance/39.3);
	return true;
}

public VipGiveAction:VIP_GiveAccess(client, ItemID, String:ItemValue[ITEM_INFO_LENGTH], bool:bCallAfterAdminAction, CURRENT_ACCESS, Handle:kv)
{
	if (g_bAccess[client]) return VGA_AlreadyEnabled;
	SetStatus(client, true);
	return VGA_Continue;
}

public VIP_TakeAccess(client, ItemID, bool:bToggledByClient)
{
	SetStatus(client, false);
}

stock SetStatus(client, bool:enabled)
{
	SDKUnhook(client, SDKHook_SetTransmit, OnTransmit);
	if ((g_bAccess[client] = enabled)) SDKHook(client, SDKHook_SetTransmit, OnTransmit);
	VIP_NotifyItemStatusChanged(client, ITEM_NAME, enabled);
}

///////////////////////////////////////////////////////////////////////////////////

public Action:OnTransmit(ring_client, client) // client смотрит на ring_client
{
	// Если client мертв, то берём не его координаты, а того, за кем он наблюдает.
	if (!IsPlayerAlive(client) && ((client = GetEntPropEnt(client, Prop_Send, "m_hObserverTarget")) < 1 || client > MaxClients))
		return Plugin_Continue;
	
	static Float:v1[3];
	static Float:v2[3];
	
	GetClientAbsOrigin(ring_client, v1);
	GetClientAbsOrigin(client, v2);
	
	return GetVectorDistance(v1, v2) >= g_fDistance ? Plugin_Handled : Plugin_Continue;
}

public OnClientDisconnect_Post(client)
	g_bAccess[client] = false;